<html>
<head>
<title>OGRE: Ogre::VertexData Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1VertexData.html">VertexData</a></div>
<h1>Ogre::VertexData Class Reference</h1><!-- doxytag: class="Ogre::VertexData" -->Summary class collecting together vertex source information.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1VertexData-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">HardwareAnimationData</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#9b0be9ce516c0b04e3565317e6186b15">HardwareAnimationDataList</a></td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#04f0100a0973983fb318cb462bfaa206">VertexData</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#cb2f442725d39e33a39f4d07f317fdc0">~VertexData</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a9b3c23ff04ac1c5b865952e71091f57">clone</a> (bool copyData=true) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Clones this vertex data, potentially including replicating any vertex buffers.  <a href="#a9b3c23ff04ac1c5b865952e71091f57"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#35751c0e63acf6def8a1cf101abd1b28">prepareForShadowVolume</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Modifies the vertex data to be suitable for use for rendering shadow geometry.  <a href="#35751c0e63acf6def8a1cf101abd1b28"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a5bf979b80f8bf95d76b7b8c34ac6fce">reorganiseBuffers</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *newDeclaration, const <a class="el" href="namespaceOgre.html#defdc0dd104d75039087a1e50eb84773">BufferUsageList</a> &amp;bufferUsage)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reorganises the data in the vertex buffers according to the new vertex declaration passed in.  <a href="#a5bf979b80f8bf95d76b7b8c34ac6fce"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#e13af5e9218486c94afabdb4598457cf">reorganiseBuffers</a> (<a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *newDeclaration)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reorganises the data in the vertex buffers according to the new vertex declaration passed in.  <a href="#e13af5e9218486c94afabdb4598457cf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#155a22e5f5cf3cc46c8890a81383ee19">closeGapsInBindings</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove any gaps in the vertex buffer bindings.  <a href="#155a22e5f5cf3cc46c8890a81383ee19"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#9c8caba4952eb43bced5051c3e3bff1f">removeUnusedBuffers</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove all vertex buffers that never used by the vertex declaration.  <a href="#9c8caba4952eb43bced5051c3e3bff1f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#0f6c57d776f87c08bb6fd6515f26270e">convertPackedColour</a> (<a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a> srcType, <a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a> destType)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert all packed colour values (VET_COLOUR_*) in buffers used to another type.  <a href="#0f6c57d776f87c08bb6fd6515f26270e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#b6b77b33c4bcf093caeafcace30dcdac">allocateHardwareAnimationElements</a> (<a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> count)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allocate elements to serve a holder of morph / pose target data for hardware morphing / pose blending.  <a href="#b6b77b33c4bcf093caeafcace30dcdac"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#bac9cde9c001b97cf1fea7fd05b79cf4">vertexDeclaration</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Declaration of the vertex to be used in this operation.  <a href="#bac9cde9c001b97cf1fea7fd05b79cf4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#1cf7dacb2a133d71620abd59cb3180b0">vertexBufferBinding</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The vertex buffer bindings to be used.  <a href="#1cf7dacb2a133d71620abd59cb3180b0"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#a3dca90128a99a8cdcd68201ad2c2f93">vertexStart</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The base vertex index to start from.  <a href="#a3dca90128a99a8cdcd68201ad2c2f93"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#0b59b63cc2dbede1c5fc6a932fd2c10d">vertexCount</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The number of vertices used in this operation.  <a href="#0b59b63cc2dbede1c5fc6a932fd2c10d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html#9b0be9ce516c0b04e3565317e6186b15">HardwareAnimationDataList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#43acb3f735c2d4bdfdfbfdebc26dc52e">hwAnimationDataList</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">VertexElements used for hardware morph / pose animation.  <a href="#43acb3f735c2d4bdfdfbfdebc26dc52e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#f24c57003d9fa3d717ca16e7f5becb41">hwAnimDataItemsUsed</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Number of hardware animation data items used.  <a href="#f24c57003d9fa3d717ca16e7f5becb41"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#154124cc2848e3eae62e9d508f45e921">hardwareShadowVolWBuffer</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Additional shadow volume vertex buffer storage.  <a href="#154124cc2848e3eae62e9d508f45e921"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#c27bb140d24d66d1f6051f47a8bb5860">VertexData</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;rhs)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Protected copy constructor, to prevent misuse.  <a href="#c27bb140d24d66d1f6051f47a8bb5860"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1VertexData.html#e1bb626aef6af169178ee9f7165aaed0">operator=</a> (const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;rhs)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Protected operator=, to prevent misuse.  <a href="#e1bb626aef6af169178ee9f7165aaed0"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">HardwareAnimationData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Struct used to hold hardware morph / pose vertex data information.  <a href="structOgre_1_1VertexData_1_1HardwareAnimationData.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Summary class collecting together vertex source information. 
<p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00043">43</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="9b0be9ce516c0b04e3565317e6186b15"></a><!-- doxytag: member="Ogre::VertexData::HardwareAnimationDataList" ref="9b0be9ce516c0b04e3565317e6186b15" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="structOgre_1_1VertexData_1_1HardwareAnimationData.html">HardwareAnimationData</a>&gt; <a class="el" href="classOgre_1_1VertexData.html#9b0be9ce516c0b04e3565317e6186b15">Ogre::VertexData::HardwareAnimationDataList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00074">74</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="c27bb140d24d66d1f6051f47a8bb5860"></a><!-- doxytag: member="Ogre::VertexData::VertexData" ref="c27bb140d24d66d1f6051f47a8bb5860" args="(const VertexData &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::VertexData::VertexData           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Protected copy constructor, to prevent misuse. 
<p>

</div>
</div><p>
<a class="anchor" name="04f0100a0973983fb318cb462bfaa206"></a><!-- doxytag: member="Ogre::VertexData::VertexData" ref="04f0100a0973983fb318cb462bfaa206" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::VertexData::VertexData           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="cb2f442725d39e33a39f4d07f317fdc0"></a><!-- doxytag: member="Ogre::VertexData::~VertexData" ref="cb2f442725d39e33a39f4d07f317fdc0" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::VertexData::~VertexData           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="e1bb626aef6af169178ee9f7165aaed0"></a><!-- doxytag: member="Ogre::VertexData::operator=" ref="e1bb626aef6af169178ee9f7165aaed0" args="(const VertexData &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>&amp; Ogre::VertexData::operator=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Protected operator=, to prevent misuse. 
<p>

</div>
</div><p>
<a class="anchor" name="a9b3c23ff04ac1c5b865952e71091f57"></a><!-- doxytag: member="Ogre::VertexData::clone" ref="a9b3c23ff04ac1c5b865952e71091f57" args="(bool copyData=true) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* Ogre::VertexData::clone           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>copyData</em> = <code>true</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Clones this vertex data, potentially including replicating any vertex buffers. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The caller is expected to delete the returned pointer when ready </dd></dl>

</div>
</div><p>
<a class="anchor" name="35751c0e63acf6def8a1cf101abd1b28"></a><!-- doxytag: member="Ogre::VertexData::prepareForShadowVolume" ref="35751c0e63acf6def8a1cf101abd1b28" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexData::prepareForShadowVolume           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Modifies the vertex data to be suitable for use for rendering shadow geometry. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Preparing vertex data to generate a shadow volume involves firstly ensuring that the vertex buffer containing the positions is a standalone vertex buffer, with no other components in it. This method will therefore break apart any existing vertex buffers if position is sharing a vertex buffer. Secondly, it will double the size of this vertex buffer so that there are 2 copies of the position data for the mesh. The first half is used for the original, and the second half is used for the 'extruded' version. The vertex count used to render will remain the same though, so as not to add any overhead to regular rendering of the object. Both copies of the position are required in one buffer because shadow volumes stretch from the original mesh to the extruded version. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>It's important to appreciate that this method can fundamentally change the structure of your vertex buffers, although in reality they will be new buffers. As it happens, if other objects are using the original buffers then they will be unaffected because the reference counting will keep them intact. However, if you have made any assumptions about the structure of the vertex data in the buffers of this object, you may have to rethink them. </dd></dl>

</div>
</div><p>
<a class="anchor" name="a5bf979b80f8bf95d76b7b8c34ac6fce"></a><!-- doxytag: member="Ogre::VertexData::reorganiseBuffers" ref="a5bf979b80f8bf95d76b7b8c34ac6fce" args="(VertexDeclaration *newDeclaration, const BufferUsageList &amp;bufferUsage)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexData::reorganiseBuffers           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td>
          <td class="paramname"> <em>newDeclaration</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#defdc0dd104d75039087a1e50eb84773">BufferUsageList</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bufferUsage</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reorganises the data in the vertex buffers according to the new vertex declaration passed in. 
<p>
Note that new vertex buffers are created and written to, so if the buffers being referenced by this vertex data object are also used by others, then the original buffers will not be damaged by this operation. Once this operation has completed, the new declaration passed in will overwrite the current one. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>newDeclaration</em>&nbsp;</td><td>The vertex declaration which will be used for the reorganised buffer state. Note that the new delcaration must not include any elements which do not already exist in the current declaration; you can drop elements by excluding them from the declaration if you wish, however. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bufferUsages</em>&nbsp;</td><td>Vector of usage flags which indicate the usage options for each new vertex buffer created. The indexes of the entries must correspond to the buffer binding values referenced in the declaration. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="e13af5e9218486c94afabdb4598457cf"></a><!-- doxytag: member="Ogre::VertexData::reorganiseBuffers" ref="e13af5e9218486c94afabdb4598457cf" args="(VertexDeclaration *newDeclaration)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexData::reorganiseBuffers           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a> *&nbsp;</td>
          <td class="paramname"> <em>newDeclaration</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Reorganises the data in the vertex buffers according to the new vertex declaration passed in. 
<p>
Note that new vertex buffers are created and written to, so if the buffers being referenced by this vertex data object are also used by others, then the original buffers will not be damaged by this operation. Once this operation has completed, the new declaration passed in will overwrite the current one. This version of the method derives the buffer usages from the existing buffers, by using the 'most flexible' usage from the equivalent sources. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>newDeclaration</em>&nbsp;</td><td>The vertex declaration which will be used for the reorganised buffer state. Note that the new delcaration must not include any elements which do not already exist in the current declaration; you can drop elements by excluding them from the declaration if you wish, however. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="155a22e5f5cf3cc46c8890a81383ee19"></a><!-- doxytag: member="Ogre::VertexData::closeGapsInBindings" ref="155a22e5f5cf3cc46c8890a81383ee19" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexData::closeGapsInBindings           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove any gaps in the vertex buffer bindings. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is useful if you've removed elements and buffers from this vertex data and want to remove any gaps in the vertex buffer bindings. This method is mainly useful when reorganising vertex data manually. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This will cause binding index of the elements in the vertex declaration to be altered to new binding index. </dd></dl>

</div>
</div><p>
<a class="anchor" name="9c8caba4952eb43bced5051c3e3bff1f"></a><!-- doxytag: member="Ogre::VertexData::removeUnusedBuffers" ref="9c8caba4952eb43bced5051c3e3bff1f" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexData::removeUnusedBuffers           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove all vertex buffers that never used by the vertex declaration. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is useful if you've removed elements from the vertex declaration and want to unreference buffers that never used any more. This method is mainly useful when reorganising vertex data manually. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This also remove any gaps in the vertex buffer bindings. </dd></dl>

</div>
</div><p>
<a class="anchor" name="0f6c57d776f87c08bb6fd6515f26270e"></a><!-- doxytag: member="Ogre::VertexData::convertPackedColour" ref="0f6c57d776f87c08bb6fd6515f26270e" args="(VertexElementType srcType, VertexElementType destType)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexData::convertPackedColour           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a>&nbsp;</td>
          <td class="paramname"> <em>srcType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#027109503a988ba85f4c63b55082907f">VertexElementType</a>&nbsp;</td>
          <td class="paramname"> <em>destType</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Convert all packed colour values (VET_COLOUR_*) in buffers used to another type. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>srcType</em>&nbsp;</td><td>The source colour type to assume if the ambiguous VET_COLOUR is encountered. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>destType</em>&nbsp;</td><td>The destination colour type, must be VET_COLOUR_ABGR or VET_COLOUR_ARGB. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="b6b77b33c4bcf093caeafcace30dcdac"></a><!-- doxytag: member="Ogre::VertexData::allocateHardwareAnimationElements" ref="b6b77b33c4bcf093caeafcace30dcdac" args="(ushort count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::VertexData::allocateHardwareAnimationElements           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a>&nbsp;</td>
          <td class="paramname"> <em>count</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Allocate elements to serve a holder of morph / pose target data for hardware morphing / pose blending. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method will allocate the given number of 3D texture coordinate sets for use as a morph target or target pose offset (3D position). These elements will be saved in hwAnimationDataList. It will also assume that the source of these new elements will be new buffers which are not bound at this time, so will start the sources to 1 higher than the current highest binding source. The caller is expected to bind these new buffers when appropriate. For morph animation the original position buffer will be the 'from' keyframe data, whilst for pose animation it will be the original vertex data. </dd></dl>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="bac9cde9c001b97cf1fea7fd05b79cf4"></a><!-- doxytag: member="Ogre::VertexData::vertexDeclaration" ref="bac9cde9c001b97cf1fea7fd05b79cf4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexDeclaration.html">VertexDeclaration</a>* <a class="el" href="classOgre_1_1VertexData.html#bac9cde9c001b97cf1fea7fd05b79cf4">Ogre::VertexData::vertexDeclaration</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Declaration of the vertex to be used in this operation. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Note that this is created for you on construction. </dd></dl>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00057">57</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1cf7dacb2a133d71620abd59cb3180b0"></a><!-- doxytag: member="Ogre::VertexData::vertexBufferBinding" ref="1cf7dacb2a133d71620abd59cb3180b0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexBufferBinding.html">VertexBufferBinding</a>* <a class="el" href="classOgre_1_1VertexData.html#1cf7dacb2a133d71620abd59cb3180b0">Ogre::VertexData::vertexBufferBinding</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The vertex buffer bindings to be used. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Note that this is created for you on construction. </dd></dl>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00061">61</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a3dca90128a99a8cdcd68201ad2c2f93"></a><!-- doxytag: member="Ogre::VertexData::vertexStart" ref="a3dca90128a99a8cdcd68201ad2c2f93" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1VertexData.html#a3dca90128a99a8cdcd68201ad2c2f93">Ogre::VertexData::vertexStart</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The base vertex index to start from. 
<p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00063">63</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="0b59b63cc2dbede1c5fc6a932fd2c10d"></a><!-- doxytag: member="Ogre::VertexData::vertexCount" ref="0b59b63cc2dbede1c5fc6a932fd2c10d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1VertexData.html#0b59b63cc2dbede1c5fc6a932fd2c10d">Ogre::VertexData::vertexCount</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The number of vertices used in this operation. 
<p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00065">65</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="43acb3f735c2d4bdfdfbfdebc26dc52e"></a><!-- doxytag: member="Ogre::VertexData::hwAnimationDataList" ref="43acb3f735c2d4bdfdfbfdebc26dc52e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html#9b0be9ce516c0b04e3565317e6186b15">HardwareAnimationDataList</a> <a class="el" href="classOgre_1_1VertexData.html#43acb3f735c2d4bdfdfbfdebc26dc52e">Ogre::VertexData::hwAnimationDataList</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
VertexElements used for hardware morph / pose animation. 
<p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00076">76</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="f24c57003d9fa3d717ca16e7f5becb41"></a><!-- doxytag: member="Ogre::VertexData::hwAnimDataItemsUsed" ref="f24c57003d9fa3d717ca16e7f5becb41" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1VertexData.html#f24c57003d9fa3d717ca16e7f5becb41">Ogre::VertexData::hwAnimDataItemsUsed</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Number of hardware animation data items used. 
<p>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00078">78</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="154124cc2848e3eae62e9d508f45e921"></a><!-- doxytag: member="Ogre::VertexData::hardwareShadowVolWBuffer" ref="154124cc2848e3eae62e9d508f45e921" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareVertexBufferSharedPtr.html">HardwareVertexBufferSharedPtr</a> <a class="el" href="classOgre_1_1VertexData.html#154124cc2848e3eae62e9d508f45e921">Ogre::VertexData::hardwareShadowVolWBuffer</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Additional shadow volume vertex buffer storage. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This additional buffer is only used where we have prepared this <a class="el" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> for use in shadow volume contruction, and where the current render system supports vertex programs. This buffer contains the 'w' vertex position component which will be used by that program to differentiate between extruded and non-extruded vertices. This 'w' component cannot be included in the original position buffer because DirectX does not allow 4-component positions in the fixed-function pipeline, and the original position buffer must still be usable for fixed-function rendering. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>Note that we don't store any vertex declaration or vertex buffer binding here becuase this can be reused in the shadow algorithm. </dd></dl>

<p>Definition at line <a class="el" href="OgreVertexIndexData_8h-source.html#l00119">119</a> of file <a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreVertexIndexData_8h-source.html">OgreVertexIndexData.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:55:09 2008
</p>
</body>
</html>
